/* TCPecho.c - main, TCPecho 
    Cesar Kallas
    02099224
*/

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

int	errno;

void	*TCPecho(void *threadid);
int	errexit(const char *format, ...);
int	connectTCP(const char *host, const char *service);

#define	LINELEN		128
char	*host = "localhost";	/* host to use if none supplied	*/
char	*service = "echo";	/* default service name		*/
char	buf[LINELEN];
char	ler[LINELEN];

#define NUM_THREADS	10000
pthread_t clientes[NUM_THREADS];
int	respostas=0;

/*------------------------------------------------------------------------
 * main - TCP client for ECHO service
 *------------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{
	int	i, ts, rc, status;
	
	switch (argc) {
	case 1:
		host = "localhost";
		break;
	case 3:
		service = argv[2];
		/* FALL THROUGH */
	case 2:
		host = argv[1];
		break;
	default:
		fprintf(stderr, "usage: TCPecho [host [port]]\n");
		exit(1);
	}
	for (i=0;i<NUM_THREADS;i++) {
		
	    // tenta criar um thread consumidor
	    ts = pthread_create(&clientes[i], NULL, TCPecho, (void *)i+1);
	    if (ts) {
	    printf("ERRO: impossivel criar um thread \n");
	    exit(-1);	
	    }
	}
	for(i=0; i<NUM_THREADS; i++){
	    rc = pthread_join(clientes[i], (void **)&status);
	    if(rc){
	    printf("ERROR; return code from pthread_join() is%d\n", rc);
	    exit(-1);
	    }
	}
	printf("Terminando o thread main(), respotas: %d\n", respostas);
	pthread_exit(NULL);
	exit(0);
}

/*------------------------------------------------------------------------
 * TCPecho - send input to ECHO service on specified host and print reply
 *------------------------------------------------------------------------
 */
void
*TCPecho(void *threadid)
{
	int	s, n;			/* socket descriptor, read count*/
	int	outchars, inchars;	/* characters sent and received	*/
	strcpy(buf, "teste de escrita\0");
	
	s = connectTCP(host, service);
	outchars = strlen(buf);
	(void) write(s, buf, outchars);
	
	/* read it back */
	for (inchars = 0; inchars < outchars; inchars+=n ) {
		n = read(s, &ler[inchars], outchars - inchars);
		if (n < 0)
			errexit("socket read failed: %s\n",
			strerror(errno));
		}
		//fputs(buf, stdout);
		printf("%s\tthreadid: %d\trespostas: %d\n", ler, threadid, ++respostas);
		fflush(stdout);
	    close(s);
}
